// Colors.prg

#include "Inkey.ch"

#xtranslate MakeColor(<nF>, <nB>)                                     ;
            =>                                                        ;
            iif(<nB> <= 7,                                            ;
                aColors\[<nF> + 1\] + "/"  + aColors\[<nB> + 1\],     ;
                aColors\[<nF> + 1\] + "*/" + aColors\[<nB> - 8 + 1\])

FUNCTION colors

LOCAL aColors := { "N",  "B",  "G",  "BG",  "R",  "RB",  "GR",  "W", ;
                   "N+", "B+", "G+", "BG+", "R+", "RB+", "GR+", "W+" }

LOCAL nFore, nBack
LOCAL cString    := "Color"
LOCAL cSelString := "Selec"
LOCAL nKey

  CLEAR SCREEN
  SET CURSOR OFF
  SetBlink(.F.)
  FOR nFore := 0 TO 15
    FOR nBack := 0 TO 15
      SetColor(MakeColor(nFore, nBack))
      @ nFore, nBack * Len(cString) SAY cString
    NEXT
  NEXT
  InKey(0)

  nKey  := 0
  nFore := 0
  nBack := 0
  DO WHILE nKey != K_ESC .AND. nKey != K_ENTER
    SetColor(MakeColor(nFore, nBack))
    @ nFore, nBack * Len(cString) SAY cSelString

    nKey := InKey(0)

    @ nFore, nBack * Len(cString) SAY cString

    DO CASE
      CASE nKey == K_UP
        nFore := Max(0, nFore - 1)

      CASE nKey == K_DOWN
        nFore := Min(15, nFore + 1)

      CASE nKey == K_LEFT
        nBack := Max(0, nBack - 1)

      CASE nKey == K_RIGHT
        nBack := Min(15, nBack + 1)

    ENDCASE
  ENDDO

  @ 24, 0 SAY "Returning " + iif(nKey == K_ESC, "", ;
                                 MakeColor(nFore, nBack))
  InKey(0)

RETURN iif(nKey == K_ESC, "", ;
           MakeColor(nFore, nBack))
