// Colors.prg

#include "Inkey.ch"

FUNCTION colors

LOCAL aColors := { "N",  "B",  "G",  "BG",  "R",  "RB",  "GR",  "W", ;
                   "N+", "B+", "G+", "BG+", "R+", "RB+", "GR+", "W+"}

LOCAL nFore, nBack
LOCAL cString := "Color"
LOCAL nKey

  CLEAR SCREEN
  SET CURSOR OFF
  FOR nFore := 0 TO 15
    FOR nBack := 0 TO 7
      SetColor(aColors[nFore + 1] + "/" + aColors[nBack + 1])
      @ nFore, nBack * Len(cString) SAY cString
    NEXT
  NEXT

  nKey  := 0
  nFore := 0
  nBack := 0
  DO WHILE nKey != K_ESC .AND. nKey != K_ENTER
    // Make selected color blink
    SetColor(aColors[nFore + 1] + "*/" + aColors[nBack + 1])
    @ nFore, nBack * Len(cString) SAY cString

    nKey := InKey(0)

    // Redisplay color without blink
    SetColor(aColors[nFore + 1] + "/" + aColors[nBack + 1])
    @ nFore, nBack * Len(cString) SAY cString
    DO CASE
      CASE nKey == K_UP
        nFore := Max(0, nFore - 1)

      CASE nKey == K_DOWN
        nFore := Min(15, nFore + 1)

      CASE nKey == K_LEFT
        nBack := Max(0, nBack - 1)

      CASE nKey == K_RIGHT
        nBack := Min(7, nBack + 1)

    ENDCASE
  ENDDO

  @ 24, 0 SAY "Returning " + iif(nKey == K_ESC, "", ;
     aColors[nFore + 1] + "/" + aColors[nBack + 1])
  InKey(0)

RETURN iif(nKey == K_ESC, "", ;
           aColors[nFore + 1] + "/" + aColors[nBack + 1])
